/*
 * Copyright 2013-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You may not use this file except in compliance with
 * the License. A copy of the License is located at
 * 
 * http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions
 * and limitations under the License.
 */
package com.amazonaws.services.identitymanagement.model.transform;

import java.util.ArrayList;

import javax.xml.stream.events.XMLEvent;
import javax.annotation.Generated;

import com.amazonaws.services.identitymanagement.model.*;
import com.amazonaws.transform.Unmarshaller;

import com.amazonaws.transform.StaxUnmarshallerContext;
import com.amazonaws.transform.SimpleTypeStaxUnmarshallers.*;

/**
 * ListEntitiesForPolicyResult StAX Unmarshaller
 */

@Generated("com.amazonaws:aws-java-sdk-code-generator")
public class ListEntitiesForPolicyResultStaxUnmarshaller implements Unmarshaller<ListEntitiesForPolicyResult, StaxUnmarshallerContext> {

    public ListEntitiesForPolicyResult unmarshall(StaxUnmarshallerContext context) throws Exception {
        ListEntitiesForPolicyResult listEntitiesForPolicyResult = new ListEntitiesForPolicyResult();
        int originalDepth = context.getCurrentDepth();
        int targetDepth = originalDepth + 1;

        if (context.isStartOfDocument())
            targetDepth += 2;

        while (true) {
            XMLEvent xmlEvent = context.nextEvent();
            if (xmlEvent.isEndDocument())
                return listEntitiesForPolicyResult;

            if (xmlEvent.isAttribute() || xmlEvent.isStartElement()) {

                if (context.testExpression("PolicyGroups", targetDepth)) {
                    listEntitiesForPolicyResult.withPolicyGroups(new ArrayList<PolicyGroup>());
                    continue;
                }

                if (context.testExpression("PolicyGroups/member", targetDepth)) {
                    listEntitiesForPolicyResult.withPolicyGroups(PolicyGroupStaxUnmarshaller.getInstance().unmarshall(context));
                    continue;
                }

                if (context.testExpression("PolicyUsers", targetDepth)) {
                    listEntitiesForPolicyResult.withPolicyUsers(new ArrayList<PolicyUser>());
                    continue;
                }

                if (context.testExpression("PolicyUsers/member", targetDepth)) {
                    listEntitiesForPolicyResult.withPolicyUsers(PolicyUserStaxUnmarshaller.getInstance().unmarshall(context));
                    continue;
                }

                if (context.testExpression("PolicyRoles", targetDepth)) {
                    listEntitiesForPolicyResult.withPolicyRoles(new ArrayList<PolicyRole>());
                    continue;
                }

                if (context.testExpression("PolicyRoles/member", targetDepth)) {
                    listEntitiesForPolicyResult.withPolicyRoles(PolicyRoleStaxUnmarshaller.getInstance().unmarshall(context));
                    continue;
                }

                if (context.testExpression("IsTruncated", targetDepth)) {
                    listEntitiesForPolicyResult.setIsTruncated(BooleanStaxUnmarshaller.getInstance().unmarshall(context));
                    continue;
                }

                if (context.testExpression("Marker", targetDepth)) {
                    listEntitiesForPolicyResult.setMarker(StringStaxUnmarshaller.getInstance().unmarshall(context));
                    continue;
                }
            } else if (xmlEvent.isEndElement()) {
                if (context.getCurrentDepth() < originalDepth) {
                    return listEntitiesForPolicyResult;
                }
            }
        }
    }

    private static ListEntitiesForPolicyResultStaxUnmarshaller instance;

    public static ListEntitiesForPolicyResultStaxUnmarshaller getInstance() {
        if (instance == null)
            instance = new ListEntitiesForPolicyResultStaxUnmarshaller();
        return instance;
    }
}
